#include <stdio.h>
#include <stdlib.h>
#include <math.h>

//#define N 720000000
#define N 3000

void iniTab (int t[], int max) {
	int i=0;
	for (i=2; i<max; i++)
		t[i]=1 ;
	t[0]=0 ;
	t[1]=0 ;
}

void affiPremier (int t[], int max) {
	int i=0;
	for (i=2; i<max; i++) {
		if (t[i]==1 )
			printf("%d ", i) ;
	}
} 

void eratosthene (int t[], int max) {
	int i, j;
	for (i=2; i<sqrt(max)+1; i++) {
		if (t[i] == 1) {
			for (j=i*i; j<max; j=j+i) {
				t[j]=0 ;
			}
		}
	}
}

int main() {
	//int tab[N] ;  // (Limite 8 Mo, soit max # 2e6 )
	int *tab ;
	tab=(int *) malloc(N*sizeof (int )); // Limite (3 Go) soit max # 8e8
	iniTab (tab, N) ;
	eratosthene(tab, N) ;
	affiPremier(tab, N) ;
	printf("\nFINI !\n");
	return (EXIT_SUCCESS);
}	

